﻿#!/usr/bin/python
# -*- coding: utf-8 -*-

import es
import playerlib
import popuplib
import psyco
import langlib
import random
psyco.full()
superhero = es.import_addon('superhero')
sh_admins = []
popup_language = str(es.ServerVar('popup_language'))
admin_msg = langlib.Strings(es.getAddonPath("superhero") + "/languages/admin_msg.ini")
admin_popup = langlib.Strings(es.getAddonPath("superhero") + "/languages/admin_popup.ini")
tokens = {}

def load():
    print "[SH] Admins loading..."
    path = es.getAddonPath("superhero/admins/adminlist.txt")
    for line in open(path):
        line = str(line).rstrip()
        if line != '0':
            if line != "":
                if not '//' in line:
                    sh_admins.append(line)
                    print "[SH] %s is now a Superhero Admin" % line
    
    print "[SH] Admins loaded..."
        
    if not es.exists('saycommand', '/sh_admin'):
        es.regsaycmd('/sh_admin', 'superhero/admins/sh_admin')
       

def sh_admin():
    userid = str(es.getcmduserid())
    steamid = str(es.getplayersteamid(userid))
    if steamid in sh_admins:
        ##### Build Admin Menu ####
        player_list = popuplib.easymenu('player_list',None,player_list_selection)
        player_list.settitle(admin_popup('admin_player_list_title',lang=popup_language))
        PlayerList = playerlib.getPlayerList('#all,#all')
        counter = 0
        
        for player in PlayerList:
            player_list.addoption(player,(str(player.name)))
            
        popuplib.send('player_list',userid)
        
    else:
        es.tell(userid,'#multi',admin_msg('admin_not',lang=popup_language))

def player_list_selection(userid,player,popup):
    if es.exists('userid',player.userid):
        superhero.Users[str(userid)]['manage_user'] = player.userid
        player_manage = popuplib.easymenu('player_manage','choice',player_manage_selection)
        player_manage.settitle(player.name)
        player_manage.setdescription('LvL '+str(superhero.Users[str(player.userid)]['level'])+' - XP '+str(superhero.Users[str(player.userid)]['xp']))
        player_manage.addoption('clear',admin_popup('admin_clear',lang=popup_language))
        player_manage.addoption('give_level',admin_popup('admin_givelevel',lang=popup_language))
        player_manage.addoption('remove_level',admin_popup('admin_remove',lang=popup_language))
        player_manage.addoption('give_50xp',admin_popup('admin_give50',lang=popup_language))
        player_manage.addoption('give_200xp',admin_popup('admin_give200',lang=popup_language))
        player_manage.addoption('save_player',admin_popup('admin_saveplayer',lang=popup_language))
        popuplib.send('player_manage',userid)
    else:
        es.tell(userid,'#multi',admin_msg('admin_notexist',lang=popup_language))

def player_manage_selection(userid,choice,popup):
    choice = str(choice)
    player = playerlib.getPlayer(superhero.Users[str(userid)]['manage_user'])
    uid = str(player.userid)
    if es.exists('userid',player.userid):
        if choice == 'clear':
            superhero.Users[uid]['unspent'] = 0
            superhero.Users[uid]['level'] = 0
            superhero.Users[uid]['xp'] = 0
            superhero.Users[uid]['heroes'] = '0'
            superhero.Users[uid]['power1'] = 0
            superhero.Users[uid]['power2'] = 0
            superhero.Users[uid]['power3'] = 0
            es.tell(uid,'#multi',admin_msg('admin_cleared',lang=popup_language))
            es.server.queuecmd('es_xsexec %s say /showxp' % uid)
            
        if choice == 'give_level':
            superhero.sh_levelup(uid,1)
            superhero.Users[uid]['xp'] = 0
            es.tell(uid,'#multi',admin_msg('admin_granted',lang=popup_language))
            es.server.queuecmd('es_xsexec %s say /showxp' % uid)
            
        if choice == 'remove_level':
            if int(superhero.Users[uid]['level']) > 0:
                superhero.Users[uid]['level'] = int(superhero.Users[uid]['level']) - 1
                if int(superhero.Users[uid]['unspent']) > 0:
                    superhero.Users[uid]['unspent'] = int(superhero.Users[uid]['unspent']) - 1
                else:
                    # Kein Unspent mehr, muss Hero entfernen
                    heroes = str(superhero.Users[uid]['heroes']).split(',')
                    leng = int(len(heroes))
     
                    try:
                        rand = int(random.randint(0,leng-1))
                        hero = str(heroes[rand])
                        if hero != '0':
                            heroes.remove(hero)
                            if str(superhero.Users[uid]['power1']) == hero:
                                superhero.Users[uid]['power1'] = '0'
                            if str(superhero.Users[uid]['power2']) == hero:
                                superhero.Users[uid]['power2'] = '0'
                            if str(superhero.Users[uid]['power3']) == hero:
                                superhero.Users[uid]['power3'] = '0'
                            
                    except:
                        None
                            
                    string = heroes[0]
                    for hero in heroes:
                        if not hero in string:
                            string = string+','+str(hero)
                    superhero.Users[uid]['heroes'] = string
                es.tell(uid,'#multi',admin_msg('admin_removed',lang=popup_language))
                es.server.queuecmd('es_xsexec %s say /showxp' % uid)
            else:
                es.tell(userid,'#multi',admin_msg('admin_already',lang=popup_language))
                
        if choice == 'give_50xp':
            superhero.sh_givexp(uid,50,admin_msg('admin_givexp',lang=popup_language))
        if choice == 'give_200xp':
            superhero.sh_givexp(uid,200,admin_msg('admin_givexp',lang=popup_language))
                
        if choice == 'save_player':
            es.server.queuecmd('es_xsexec %s say /savexp' % uid)
        
    es.server.queuecmd('es_xsexec %s say /sh_admin' % userid)