﻿#!/usr/bin/python
# -*- coding: utf-8 -*-
import es
import playerlib
import time
import effectlib
import psyco
import gamethread
psyco.full()
superhero = es.import_addon('superhero')

def load():
    print "[SH] Iron Man successfully loaded"

def unload():
    gamethread.cancelDelayed(fuel_regen)

def es_map_start(ev):
    gamethread.cancelDelayed(fuel_regen)

def player_spawn(ev):
    userid = str(ev['userid'])
    if superhero.hasHero(userid,'Iron Man'):
        gamethread.cancelDelayed(fuel_regen)
        player = playerlib.getPlayer(userid)
        wcs_dead = player.isdead
        if wcs_dead != 1:
            superhero.Users[userid]['Thrust'] = 0
            superhero.Users[userid]['Regenfuel'] = 1
            player.armor = 150
            fuel_regen()
        
def player_death(ev):
    userid = str(ev['userid'])
    if superhero.hasHero(userid,'Iron Man'):
        superhero.Users[userid]['Regenfuel'] = 0
            
def round_end(ev):
    userid = str(ev['userid'])
    if superhero.hasHero(userid,'Iron Man'):
        gamethread.cancelDelayed(fuel_regen)
        superhero.Users[userid]['Regenfuel'] = 0
        
def power():
    userid = str(es.getcmduserid())
    player = playerlib.getPlayer(userid)
    if int(player.isdead) != 1:
        powerx = str(superhero.Users[userid]['powerx'])
        if superhero.Users[userid][powerx] == 'Iron Man':
            superhero.Users[userid]['Thrust'] = 1
            IronManLoop(userid)
            
def poweroff():
    userid = str(es.getcmduserid())
    player = playerlib.getPlayer(userid)
    if int(player.isdead) != 1:
        powerx = str(superhero.Users[userid]['powerx'])
        if superhero.Users[userid][powerx] == 'Iron Man':
            superhero.Users[userid]['Thrust'] = 0
        
def IronManLoop(userid):
        if superhero.Users[userid]['Thrust'] == 1:
            player = playerlib.getPlayer(userid)
            if player.armor > 1:
                player.armor = player.armor - 2
                loc = es.getplayerlocation(userid)
                effectlib.drawBox(loc, [loc[0] + 10, loc[1] + 10, loc[2]], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", 0.2, 20, 20, 255, 0, 0, 255, 10, 0, 0, 0, 0)
                effectlib.drawBox(loc, [loc[0] - 10, loc[1] - 10, loc[2]], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", 0.2, 20, 20, 255, 128, 0, 255, 10, 0, 0, 0, 0)
                effectlib.drawBox([loc[0] - 5, loc[1] - 5, loc[2]], [loc[0] + 5, loc[1] + 5, loc[2]], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", 0.2, 20, 20, 0, 0, 255, 255, 10, 0, 0, 0, 0)
                playerlib.getPlayer(userid).set("push", (0, 145, True))
                es.emitsound('player', userid, 'ambient/explosions/exp4.wav', '0.3', '0.4')
                gamethread.delayed(0.1, IronManLoop, userid)
            else:
                es.tell(userid, '#multi', '#green[SH]#lightgreen Not enough fuel, wait until it regens.')
        
def fuel_regen():
    for userid in superhero.Users:
        if es.exists('userid',userid):
            try:
                player = playerlib.getPlayer(userid)
            except:
                gamethread.delayed(1, fuel_regen)
            finally:
                player = playerlib.getPlayer(userid)
            if int(player.isdead) != 1:
                if superhero.hasHero(userid, 'Iron Man'):
                    if superhero.Users[userid]['Thrust'] == 0:
                        fuel = player.armor
                        if fuel < 150:
                            player.armor = fuel + 1
                if 'Regenfuel' in superhero.Users[userid]:
                    if superhero.Users[userid]['Regenfuel'] == 1:
                        gamethread.delayedname(0.25, fuel_regen, fuel_regen)